*
* Fade to Picture Module
* Original Fade Routine by Tom Bajoras
*

* Modified to work as Warp 9 screensaver module
* by Charles F. Johnson

* Picture Fader loads a DEGAS uncompressed picture called PICFADE.PI?, and
* dissolves between the picture and the user's screen at definable
* intervals.

* The GEM object tree included in this assembly source code was created with
* RSC->ASM, one of the programs available on the CodeHead Utilities disk.

* This module assumes a screen size of 32K, because it is only written to
* load uncompressed DEGAS pictures.  Ideally, modules should be able to
* adjust themselves to any screen size; but if a module cannot adjust
* itself this way, be sure to limit its legal resolutions with the
* rezvalid variable in the module header. 

* Last revision: Tuesday, September 8, 1992  12:56:08 pm

*------------------------------------------------------------------------
* Warp 9 backdoor structure

	.ABS

q_reserved:	ds.b	208	; Internal stuff used by Warp 9

q_saveonoff:	ds.b	1	; Global screensaver on/off flag (0=off)
q_notu1:	ds.b	1	; Not used
q_savetime:	ds.l	1	; Time to wait before saving (in 200hz ticks)
q_saveflag:			; High byte of counter is saveflag
q_savecount:	ds.l	1	; Count up inactivity timer
q_saveinterval:	ds.l	1	; Interval to call periodic routine
q_saveintcount:	ds.l	1	; Interval countdown timer
q_kickin:	ds.l	1	; Pointer to screensaver kick-in routine
q_screensave:	ds.l	1	; Pointer to periodic screensaver routine
q_kickout:	ds.l	1	; Pointer to kick-out routine

q_saveprefs:	ds.b	1	; screensaver preferences
				;   bit 0 = watch GEM Graphics/Text
				;   bit 1 = watch GEMDOS/Bios Text
				;   bit 2 = watch RS-232 Input
				;   bit 3 = watch MIDI Input

q_extflag:	ds.b	1	; External screensaver modules should set this

*------------------------------------------------------------------------
* Object structure

	.ABS

_nextchild:	ds.w	1
_1stchild:	ds.w	1
_lastchild:	ds.w	1
_otype:		ds.w	1
_oflags:	ds.w	1
_ostatus:	ds.w	1
_ospec:		ds.l	1
_xcoord:	ds.w	1
_ycoord:	ds.w	1
_width:		ds.w	1
_height:	ds.w	1
obj_scalar:	ds.w	0

* Object flag bit equates

selectable	=	0
default		=	1
_exit		=	2
editable	=	3
rbutton		=	4
lastob		=	5
touchexit	=	6
hidetree	=	7

* Object state bit equates

selected	=	0
crossed		=	1
checked		=	2
disabled	=	3
outlined	=	4
shadowed	=	5

* Miscellaneous stuff

ted_scalar	=	28

*------------------------------------------------------------------------

	.INCLUDE "AES_EQU.S"

*------------------------------------------------------------------------

	.TEXT

	bra	start_module

*------------------------------------------------------------------------
mod_header:
magic:		dc.l	'WARP'		; Module ID
init:		dc.l	init_module	; Pointer to init routine
config:		dc.l	config_module	; No configuration routine
remove:		dc.l	remove_module	; Pointer to remove/cleanup routine

myname:		dc.b	'Picture Fader'	; Title string maximum 24 bytes
namend:		dcb.b	24-(namend-myname),32	; Pad with spaces to 24 chars
		dc.b	0,0		; *** myname must be 26 bytes total ***

myauthor:	dc.b	'Tom Bajoras/C. Johnson'
authend:	dcb.b	24-(authend-myauthor),32
		dc.b	0,0

rezvalid:	dc.w	%00000110	; Valid screen resolutions
					; (bit numbers correspond to screen res)

scrbuf:		dc.l	0		; Pointer to screen buffer
scrsize:	dc.l	0		; Screen buffer size in bytes
backdoor:	dc.l	0		; Pointer to Warp 9 backdoor
aespb:		dc.l	0		; Pointer to loader's aespb
mypath:		dcb.b	128,0		; Directory where the module lives

	.ASSERT (myauthor-myname)=26	; Make sure myname is 26 bytes
	.ASSERT (rezvalid-myauthor)=26	; Make sure myauthor is 26 bytes

*-----------------------------------------------------------------------------
start_module:
	clr	-(sp)			; Just quit
	trap	#1

*-----------------------------------------------------------------------------
* Module initialization

init_module:
	move	#$37F,-(sp)	; Illegal XBIOS call - on return, the address
	trap	#14		; of the XBIOS jump table is in A0
	addq	#2,sp		; This is kinda nasty, but Allan Pratt did
	subq	#2,a0		; say he'd support it
	move.l	a0,xbios_tbl

.fix:	move.l	aespb(pc),d0	; Look at aespb pointer
	beq	.bad		; If it's zero, forget it

	move.l	d0,a5		; Move it to where it can do some good
	move.l	16(a5),a0	; Pointer to addrin
	move.l	#tslowdiss,(a0)	; Set address of object tree
	move.l	8(a5),a3	; Pointer to intin
	move	#num_obs-1,d5	; Number of objects in tree
.acc2:	move	d5,(a3)		; Set obj number
	move.l	#rsrc_obfix,d0	; Fix 'em up
	bsr	aes
	dbf	d5,.acc2

	move.w	#4,-(sp)	; Get resolution
	trap	#14
	addq	#2,sp
	add.b	#'1',d0
	move.b	d0,picname+10	; Set correct Degas picture name
	move.b	d0,errnam+10	; Also stuff it in the error alert

	lea	mypath(pc),a0	; This is where I live
	lea	cnfname,a1	; Space for the full pathname of the config file
.c0:	move.b	(a0)+,(a1)+
	bne	.c0
	subq	#1,a1
	lea	piccnf(pc),a0	; This is my config file
.c1:	move.b	(a0)+,(a1)+
	bne	.c1

	lea	mypath(pc),a0	; Home sweet home
.z0:	tst.b	(a0)+		; Find the end of the path
	bne	.z0
	subq	#1,a0
	lea	picname(pc),a1	; Store picture name right there
.z1:	move.b	(a1)+,(a0)+
	bne	.z1

	clr	-(sp)		; Try to open the config file
	pea	cnfname
	move.w	#$3D,-(sp)
	trap	#1
	addq	#8,sp
	tst.w	d0
	bmi.s	.open0		; If we can't, skip to the picture file

	move.w	d0,d5		; Read the delay and fadeval variables
	pea	delay(pc)
	move.l	#4,-(sp)
	move	d5,-(sp)
	move	#$3F,-(sp)
	trap	#1
	lea	12(sp),sp

	move	d5,-(sp)	; Close it
	move	#$3E,-(sp)
	trap	#1
	addq	#4,sp

	st	gotcnf		; Yes, we did find a config file

.open0:	clr	-(sp)		; Try to open PICFADE.PI?
	pea	mypath(pc)
	move.w	#$3D,-(sp)
	trap	#1
	addq	#8,sp
	tst.w	d0
	bpl.s	.read1

	move.l	16(a5),a0	; A5 still holds aespb address
	move.l	#picerr,(a0)	; Display error alert box
	move.l	8(a5),a3	; intin
	move.w	#1,(a3)
	move.l	#form_alert,d0
	bsr	aes
	bra	.bad

.read1:	move.w	d0,d7		; Read resolution from picture
	pea	picbuf		; (and do nothing with it)
	move.l	#2,-(sp)
	move.w	d7,-(sp)
	move	#$3F,-(sp)
	trap	#1
	lea	12(sp),sp
	tst.l	d0
	bpl.s	.read2

.readx:	move.w	d7,-(sp)	; If error, close the file and bail
	move	#$3E,-(sp)
	trap	#1
	addq	#4,sp
	bra.s	.bad

.read2:	pea	picpalette	; Read the color palette
	move.l	#32,-(sp)
	move	d7,-(sp)
	move	#$3F,-(sp)
	trap	#1
	lea	12(sp),sp
	tst.l	d0
	bmi	.readx

	pea	picbuf		; Picture data
	move.l	#32000,-(sp)
	move	d7,-(sp)
	move	#$3F,-(sp)
	trap	#1
	lea	12(sp),sp
	tst.l	d0
	bmi	.readx

	move.w	d7,-(sp)	; Close it
	move	#$3E,-(sp)
	trap	#1
	addq	#4,sp

	move.l	backdoor(pc),d0
	beq.s	.bad

	move.l	d0,a0		; Set the necessary entries in Warp 9's backdoor
	move.l	#kick_in,q_kickin(a0)
	move.l	#periodic,q_screensave(a0)
	move.l	#kick_out,q_kickout(a0)
	move.l	#1,q_saveinterval(a0)
	move.l	q_saveinterval(a0),q_saveintcount(a0)
	st	q_extflag(a0)

	moveq	#0,d0		; Return successful status
	rts

.bad:	moveq	#-1,d0		; Return error
	rts

*-----------------------------------------------------------------------------
config_module:
	move.l	delay(pc),vsave	; Save current config values

	bclr	#selected,oslowbt+11	; Set up the dialog box buttons
	bclr	#selected,omedbt+11
	bclr	#selected,ofastbt+11

	move.w	fadeval(pc),d0
	cmp.w	#2,d0
	bne.s	.ckmed

	bset	#selected,oslowbt+11
	bra.s	.cnf0

.ckmed:	cmp.w	#10,d0
	bne.s	.ckfas

	bset	#selected,omedbt+11
	bra.s	.cnf0

.ckfas:	bset	#selected,ofastbt+11

.cnf0:	lea	sfadeint(pc),a0	; Make the current fade interval into ASCII
	moveq	#0,d0
	move.w	delay(pc),d0
	divu	#60,d0
	and.l	#$FFFF,d0
	bsr	bindec2

	move.l	aespb(pc),a5
	move.l	16(a5),a0
	move.l	#tslowdiss,(a0)
	move.l	#form_center,d0	; Get centered coordinates for dialog
	bsr	aes

	move.l	12(a5),a0	; Move coordinates to intin array
	move.l	8(a5),a3
	movem.l	2(a0),d0-d1
	movem.l	d0-d1,4(a3)
	move.l	#8,(a3)
	move.l	#objc_draw,d0	; Draw the dialog box
	bsr	aes

	move.l	#form_do,d0	; Get user input
	bsr	aes

	bclr	#selected,opfadeok+11	; Deselect the exit button

	move.w	#2,fadeval	; Set fadeval according to radio buttons
	btst	#selected,oslowbt+11(pc)
	bne.s	.cnf1

	move.w	#10,fadeval
	btst	#selected,omedbt+11(pc)
	bne.s	.cnf1

	move.w	#50,fadeval

.cnf1:	lea	sfadeint(pc),a0	; Convert the decimal ASCII number to binary
	bsr	decbin
	tst.w	d0
	beq.s	.out

	mulu	#60,d0		; seconds * 60 = number of vblanks
	move.w	d0,delay

.out:	move.l	delay(pc),d0	; Have the settings changed?
	cmp.l	vsave(pc),d0
	beq.s	.out2		; If not, exit

	tst	gotcnf		; Did we find a cnf file?
	beq.s	.creat		; If not, go create one

	move.w	#2,-(sp)	; open for read/write
	pea	cnfname
	move.w	#$3D,-(sp)
	trap	#1
	addq	#8,sp
	tst.w	d0
	bpl.s	.writ

.creat:	clr	-(sp)
	pea	cnfname
	move	#$3C,-(sp)	; Fcreate
	trap	#1
	addq	#8,sp
	tst.w	d0
	bmi.s	.out2

.writ:	move	d0,d5
	pea	delay(pc)
	move.l	#4,-(sp)
	move	d5,-(sp)
	move	#$40,-(sp)	; Write config file
	trap	#1
	lea	12(sp),sp

	move	d5,-(sp)	; Close the file
	move	#$3E,-(sp)
	trap	#1
	addq	#4,sp

.out2:	rts

*-----------------------------------------------------------------------------
* AES subroutine

aes:	movem.l	d0-d1/a0-a1,-(sp)
	move.l	aespb(pc),a0
	move.l	(a0),a1
	movep.l	d0,1(a1)
	move.l	a0,d1
	move	#$C8,d0
	trap	#2
	movem.l	(sp)+,d0-d1/a0-a1
	rts

*-----------------------------------------------------------------------------
bindec2:
	movem.l	d0-d1/a0,-(sp)
	addq	#2,a0
	moveq	#1,d1
.loop:	ext.l	d0
	divu	#10,d0
	swap	d0
	move.b	d0,-(a0)
	add.b	#'0',(a0)
	swap	d0
	dbra	d1,.loop
	movem.l	(sp)+,d0-d1/a0
	rts
*-----------------------------------------------------------------------------
decbin:	movem.l	d1/a0,-(sp)
	moveq	#0,d0
.loop:	cmp.b	#'9',(a0)
	bhi.s	.notdc
	cmp.b	#'0',(a0)
	blo.s	.notdc
	lsl	#1,d0
	move.l	d0,d1
	lsl	#2,d0
	add.l	d1,d0
	move.b	(a0)+,d1
	and.l	#$0F,d1
	add.l	d1,d0
	bra	.loop
.notdc:	movem.l	(sp)+,d1/a0
	rts
*-----------------------------------------------------------------------------

	dc.l	'WARP'

remove_module:
	clr.l	kick_in-4
	rts

*-----------------------------------------------------------------------------
* Kick-in routine

	dc.l	'WARP'

kick_in:
	move.l	$44E,a0		; Address of screen memory
	lea	screenbuf,a1	; Save buffer
	move.w	#499,d0		; 500*64=32000
.c0:	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	dbf	d0,.c0

	clr.w	dissflag
	clr.w	progflag
	clr.w	timer

	move.l	backdoor(pc),a0
	move.l	q_saveinterval(a0),q_saveintcount(a0)

	lea	$FF8240,a0
	move.l	a0,a2
	lea	syspalette,a1
	moveq	#15,d0
.pal0:	move	(a0)+,(a1)+
	dbf	d0,.pal0
	lea	picpalette,a1
	moveq	#15,d0
.pal1:	move	(a1)+,(a2)+
	dbf	d0,.pal1

	bsr.s	periodic
	rts

*-----------------------------------------------------------------------------
* Periodic routine

periodic:
	tst.w	progflag
	beq.s	.per0

	movem.l	myregs(pc),d0-a6
	bra	.big

.per0:	tst.w	timer
	beq.s	.per1

	subq.w	#1,timer
	rts

.per1:	eor	#1,progflag

	lea	screenbuf,a4
	tst.w	dissflag
	bne.s	.scr0

	lea	picbuf,a4

.scr0:	move.l	$44E,a5

	moveq	#20,d4		; d4=interleave
	cmp.b	#2,$44C
	beq.s	.hi

	moveq	#40,d4

.hi:	moveq	#0,d1
	move.l	d1,d2

	lea	elbow,a0
	move.l	a0,d3
	add.l	#2000,d3

.clr0:	moveq	#0,d0
	move	d1,d2
	add	d4,d2

.clr1:	move	d1,(a0,d0.w)
	addq	#1,d1
	addq	#2,d0
	cmp	d2,d1
	blo	.clr1

	move.w	d4,d2
	lsl	#1,d2
	add	d2,a0
	lsr	#1,d2
	mulu	#7,d2
	add	d2,d1
	cmp.l	d3,a0
	blo	.clr0

	move	#1000,d7
	lea	elbow,a3
	move.w	d4,d3
	lsl	#2,d3		; 4*interleave for long index++

.big:	move.w	fadeval(pc),counter	; 1000 is divisible by 4 (250)

.big2:	move.l	xbios_tbl,a0
	move.l	70(a0),a0	; Pointer to XBIOS Random() (17*4+2)
	moveq	#0,d0
	movem.l	d1-a6,-(sp)
	move.l	d0,a5
	jsr	(a0)		; Call XBIOS directly
	movem.l	(sp)+,d1-a6

	and.l	#$ffff,d0
	divs	d7,d0
	swap	d0
	move	d0,d5		; i = random() % maxindex

	lsl	#1,d5
	move	(a3,d5.w),d6	; j=scrindex[i]

	subq	#1,d7
	move	d7,d0
	lsl	#1,d0
	move	(a3,d0.w),(a3,d5.w)
	move	d6,(a3,d0.w)	; swap the two

	lsl.l	#2,d6
	move	#7,d0
.small:	move.l	(a4,d6.w),(a5,d6.w)
	add	d3,d6
	dbf	d0,.small

	subq	#1,counter
	bne	.big2

	tst	d7
	beq.s	.exit

	movem.l	d0-a6,myregs
	rts

.exit:	clr.w	progflag
	eor	#1,dissflag
	move.w	delay(pc),timer

	rts

*-----------------------------------------------------------------------------
* Kick-out routine

kick_out:
	lea	screenbuf,a0
	move.l	$44E,a1
	move.w	#499,d0
.c0:	move.l	(a0)+,(a1)+	; Restore the screen
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	dbf	d0,.c0

	lea	syspalette,a0
	lea	$FF8240,a1
	moveq	#15,d0
.pal0:	move	(a0)+,(a1)+
	dbf	d0,.pal0

.out:	clr.w	timer
	rts

*-----------------------------------------------------------------------

delay:		dc.w	180
fadeval:	dc.w	2
vsave:		dc.l	0

* ---------- Source code conversion from PICFADE.RSC ----------

* ---------- Equates --------------------

slowdiss=	0	; tree
slowbt	=	3	; object in slowdiss tree
medbt	=	4	; object in slowdiss tree
fastbt	=	5	; object in slowdiss tree
fadeint	=	6	; object in slowdiss tree
pfadeok	=	8	; object in slowdiss tree

num_tree=	1
num_obs =	9

G_BOX      =  20
G_TEXT     =  21
G_BOXTEXT  =  22
G_IMAGE    =  23
G_PROGDEF  =  24
G_IBOX     =  25
G_BUTTON   =  26
G_BOXCHAR  =  27
G_STRING   =  28
G_FTEXT    =  29
G_FBOXTEXT =  30
G_ICON     =  31
G_TITLE    =  32

NONE       = %000000000
SELECTABLE = %000000001
DEFAULT    = %000000010
EXIT       = %000000100
EDITABLE   = %000001000
RBUTTON    = %000010000
LASTOB     = %000100000
TOUCHEXIT  = %001000000
HIDETREE   = %010000000
INDIRECT   = %100000000

NORMAL     = %000000
SELECTED   = %000001
CROSSED    = %000010
CHECKED    = %000100
DISABLED   = %001000
OUTLINED   = %010000
SHADOWED   = %100000

	.even

* ---------- Ted Info Structures --------------------

ted0:
	dc.l	str0,null,null
	dc.w	3,6,2,$1071,0,2,22,1
efadeint:
	dc.l	str7,str8,str9
	dc.w	3,6,0,$1180,0,-1,3,18
ted2:
	dc.l	str10,null,null
	dc.w	3,6,0,$1180,0,-1,4,1

* ---------- Object Trees --------------------

tslowdiss:					; (tree 0)
obj0:
	dc.w	-1,1,8,G_BOX,NONE,OUTLINED
	dc.l	$21100
	dc.w	0,0,30,10
obj1:
	dc.w	2,-1,-1,G_BOXTEXT,NONE,NORMAL
	dc.l	ted0
	dc.w	0,0,30,2
obj2:
	dc.w	3,-1,-1,G_STRING,NONE,NORMAL
	dc.l	str3
	dc.w	10,2,10,2
oslowbt:
	dc.w	4,-1,-1,G_BUTTON,%00010001,NORMAL
	dc.l	str4
	dc.w	2,4,8,1
omedbt:
	dc.w	5,-1,-1,G_BUTTON,%00010001,SELECTED
	dc.l	str5
	dc.w	11,4,8,1
ofastbt:
	dc.w	6,-1,-1,G_BUTTON,%00010001,NORMAL
	dc.l	str6
	dc.w	20,4,8,1
ofadeint:
	dc.w	7,-1,-1,G_FTEXT,EDITABLE,NORMAL
	dc.l	efadeint
	dc.w	4,6,17,1
obj7:
	dc.w	8,-1,-1,G_TEXT,NONE,NORMAL
	dc.l	ted2
	dc.w	22,6,4,1
opfadeok:
	dc.w	0,-1,-1,G_BUTTON,%00100111,NORMAL
	dc.l	str13
	dc.w	20,8,8,1

* ---------- Strings --------------------

null:	dc.b	0
str0:	dc.b	"PicFade Configuration",0
str3:	dc.b	"Fade Speed",0
sslowbt:
str4:	dc.b	"Slow",0
smedbt:
str5:	dc.b	"Medium",0
sfastbt:
str6:	dc.b	"Fast",0
sfadeint:
str7:	dc.b	"__",0
str8:	dc.b	"Fade Interval: __",0
str9:	dc.b	"9",0
str10:	dc.b	"sec",0
spfadeok:
str13:	dc.b	"OK",0

	.EVEN

myregs:		dcb.l	16,0
picname:	dc.b	'PICFADE.PI3',0
piccnf:		dc.b	'PICFADE.CNF',0

picerr:		dc.b	'[3]['
		dc.b	' The Picture Fader |'
		dc.b	' cannot locate|'
		dc.b	' '
errnam:		dc.b	'PICFADE.PI3 ...]'
		dc.b	'[Cancel]',0

	.EVEN
	.BSS

screenbuf:	ds.b	32000
picbuf:		ds.b	32000
elbow:		ds.b	$1000
picpalette:	ds.w	16
syspalette:	ds.w	16
xbios_tbl:	ds.l	1
dissflag:	ds.w	1
progflag:	ds.w	1
counter:	ds.w	1
timer:		ds.w	1
gotcnf:		ds.w	1
cnfname:	ds.b	128

	.END

